<div class="loading-shade" *ngIf="dataSource.loading$ | async">
  <mat-progress-bar *ngIf="dataSource.loading$ | async" mode="indeterminate"></mat-progress-bar>
</div>

<mat-card class="m-4">
  <div class="ft-weight-900 f-24 fm-rauth">{{snakeToTitleCase(model)}} ({{dataSource.length}})</div>
</mat-card>

<mat-card class="m-4">
  <div class="flex justify-between mb-3">
    <div>
      <input type="text" class="searchbox" placeholder="Search Users...." [(ngModel)]="search" (input)="searchSubject.next(search)"
      (keyup.enter)="setFilter()">
    </div>
    <button class="secondary flex justify-center items-center" (click)="routeNew()"><mat-icon>add</mat-icon> <div>Add {{snakeToTitleCase(model)}}</div></button>
  </div>
  <div [ngClass]="dataSource.data?.length == 0 ? 'hidden' : 'block'">
    <div class="table-block">
      <table mat-table class="full-width-table" [dataSource]="dataSource" matSort aria-label="Elements">
        <!-- Name Column -->
        <ng-container matColumnDef="name">
          <th mat-header-cell *matHeaderCellDef mat-sort-header (click)="setFilter()" id="name">Name</th>
          <td mat-cell *matCellDef="let row">
            <a *ngIf="model !== 'cors_domain'" [routerLink]="['/', 'admin', 'form', model, row.uuid]">{{row.name}}</a>
            <a *ngIf="model === 'cors_domain'" [routerLink]="['/', 'admin', 'form', model, row.uuid]">{{row.domain}}</a>
          </td>
        </ng-container>

        <!-- UUID Column -->
        <ng-container matColumnDef="uuid">
          <th mat-header-cell *matHeaderCellDef id="uuid">UUID</th>
          <td mat-cell *matCellDef="let row">
            <a [routerLink]="['/', 'admin', 'form', model, row.uuid]">{{row.uuid}}</a>
          </td>
        </ng-container>

        <ng-container matColumnDef="actions">
          <th mat-header-cell *matHeaderCellDef id="actions">Actions</th>
          <td mat-cell *matCellDef="let row">
            <div class="cursor-pointer" [routerLink]="['/', 'admin', 'form', model, row.uuid]">
              <mat-icon>settings</mat-icon>
            </div>
          </td>
        </ng-container>

        <tr mat-header-row *matHeaderRowDef="displayedColumns; sticky: true"></tr>
        <tr mat-row *matRowDef="let row; columns: displayedColumns;"></tr>
      </table>
    </div>
      <mat-paginator #paginator class="mat-paginator-sticky" (page)="getUpdate($event)" [length]="dataSource.length"
        [pageSizeOptions]="[10, 50, 100, 500]">
      </mat-paginator>

  </div>
  <ng-container *ngIf="dataSource.data?.length == 0">
    <div class="flex justify-center">No records found</div>
  </ng-container>
</mat-card>